"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RedisQueueEventsBus = void 0;
const BaseQueueEventsBus_1 = require("./BaseQueueEventsBus");
class RedisQueueEventsBus extends BaseQueueEventsBus_1.BaseQueueEventsBus {
    constructor(options) {
        super();
        this.redisPool = options.redisPool;
        this.eventsChannel = 'QUERY_QUEUES:EVENTS';
        this.initSubscriber();
    }
    async initSubscriber() {
        const redisClientSubscriber = await this.redisPool.getClient();
        redisClientSubscriber.subscribe(this.eventsChannel, (err) => {
            if (err) {
                console.error('Failed to subscribe: %s', err.message);
            }
        });
        redisClientSubscriber.on('message', async (channel, message) => {
            try {
                message = JSON.parse(message);
                await Promise.all(Object.values(this.subscribers).map(subscriber => subscriber.callback(message)));
            }
            catch (error) {
                console.error(error.stack || error);
            }
        });
    }
}
exports.RedisQueueEventsBus = RedisQueueEventsBus;
//# sourceMappingURL=RedisQueueEventsBus.js.map